      $set sourceformat "free" 
        
       IDENTIFICATION DIVISION.
       PROGRAM-ID. ListTable. 
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01 emp-group-item.
       05  uname           pic x(16).
       05  phone          PIC x(16).
       01 cursor-switch pic x value 'n'.
        88 end-of-cursor value 'y'.
        
       EXEC SQL INCLUDE SQLCA END-EXEC.
    
       PROCEDURE DIVISION.
       MAIN SECTION 01.
       BEGIN.
      
       EXEC SQL CONNECT TO 
       'jdbc:postgresql://demodb.cb2oygtzn1cl.us-east-1.rds.amazonaws.com:5432/demo'
       USER 'demo'
               PASSWORD 'demouser'
               DRIVER 'org.postgresql.Driver'
       END-EXEC.      
        
       IF SQLCODE NOT = 0 
        DISPLAY "FAILED TO CONNECT TO DATABASE " SQLCODE " " SQLERRM
        UPON SYSERR
        GO TO FIN
       END-IF. 
              
       EXEC SQL declare csr1 cursor for
          select name
                ,phone
          from demo_table
       END-EXEC. 
       
       EXEC SQL
            open csr1
       END-EXEC.
       IF SQLCODE NOT = 0 
               DISPLAY "FAILED TO OPEN CURSOR CSR1 " SQLCODE " " SQLERRM
               UPON SYSERR
               GO TO FIN
       END-IF

       perform until end-of-cursor       
         EXEC SQL 
            fetch csr1
            into :uname      
                ,:phone  
         END-EXEC   
       
         if sqlcode = 0
            display 'name: ' uname  ' : ' phone upon sysout
         else
            display 'sqlcode: ' sqlcode upon sysout
            set end-of-cursor to true
         end-if
       end-perform.
       
       EXEC SQL
            close csr1
       END-EXEC.
                 
       DISPLAY "End of Program." upon sysout.
       FIN.
        stop run.

