       IDENTIFICATION DIVISION.
       PROGRAM-ID. ONLREAD.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01    WS-COMM      PIC X(4).
             COPY ONLREAD.
             COPY DFHBMSCA.
             COPY DFHAID.
             EXEC SQL
                 INCLUDE SQLCA
             END-EXEC.
             EXEC SQL
                INCLUDE DCLGENF
             END-EXEC.
       01 emp-group-item.
       05  uname           pic x(16).
       05  phone          PIC  x(16).
       01 cursor-switch pic x value 'n'.
        88 end-of-cursor value 'y'.
        
       LINKAGE SECTION.
       01    DFHCOMMAREA    PIC X(4).
       PROCEDURE DIVISION.
       MAIN-PARA.
             move dfhcommarea(1:eibcalen) to WS-COMM.
             MOVE LOW-VALUES TO ONLREADI.
             IF EIBCALEN = 0
                MOVE '2' TO WS-COMM
                PERFORM SEND-MAP THRU SEND-MAP-EXIT
                PERFORM RETURN-PARA THRU RETURN-EXIT
             ELSE
                PERFORM RECEIVE-PARA THRU RECEIVE-PARA-EXIT
                PERFORM KEY-PARA THRU KEY-PARA-EXIT
                PERFORM EXIT-PARA
             END-IF.
       SEND-MAP.
             EXEC CICS SEND
                MAP('ONLREAD')
                MAPSET('ONLREAD')
                FREEKB
                ERASE
             END-EXEC.
       SEND-MAP-EXIT.
             EXIT.
       RETURN-PARA.
             EXEC CICS RETURN
                 TRANSID('ONLR')
                 COMMAREA(WS-COMM)
             END-EXEC.
       RETURN-EXIT.
             EXIT.
       RECEIVE-PARA.
             MOVE LOW-VALUES TO ONLREADI.
             EXEC CICS RECEIVE
                 MAP('ONLREAD')
                 MAPSET('ONLREAD')
             END-EXEC.
       RECEIVE-PARA-EXIT.
             EXIT.
       KEY-PARA.
            EVALUATE EIBAID
               WHEN DFHPF5
                 PERFORM FETCH-PARA
                PERFORM SEND-MAP THRU SEND-MAP-EXIT
               WHEN OTHER
                    MOVE 'PRESS RIGHT KEY' TO MESSO
             END-EVALUATE.
       KEY-PARA-EXIT.
             EXIT.
       FETCH-PARA.
             MOVE NAMEI TO HI-NAME-TEXT.
             COMPUTE HI-NAME-LEN = FUNCTION LENGTH(NAMEI).
             MOVE PHONEI TO HI-PHONE-TEXT.
             COMPUTE HI-PHONE-LEN = FUNCTION LENGTH(PHONEI).
             

             
             
             MOVE "UNKNOWN" TO MESSO
             
             EXEC SQL declare csr1 cursor for
                select name,phone
                from demo_table where name = :HI-NAME
                
             END-EXEC. 
       
             EXEC SQL
                open csr1
             END-EXEC.
             IF SQLCODE NOT = 0 
               MOVE "UNKNOWN" TO MESSO
               DISPLAY SQLCODE UPON SYSOUT
               DISPLAY SQLERRMC UPON SYSOUT
               GO TO FIN
             END-IF
        
             perform until end-of-cursor       
                EXEC SQL 
                fetch csr1
                into :uname,:phone     
                END-EXEC   
       
                if sqlcode = 0
                        MOVE phone TO MESSO
                        set end-of-cursor to true
                        
                else
                        MOVE "UNKNOWN" TO MESSO
                        DISPLAY SQLCODE UPON SYSOUT
                        DISPLAY SQLERRMC UPON SYSOUT
            set end-of-cursor to true
            end-if
         
            end-perform.
       
            EXEC SQL
                close csr1
            END-EXEC.
       FIN.
       EXIT-PARA.
             EXEC CICS RETURN
             END-EXEC.
