       IDENTIFICATION DIVISION.
       PROGRAM-ID. ONLDEMO.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01    WS-COMM      PIC X(4).
             COPY ONLDEMO.
             COPY DFHBMSCA.
             COPY DFHAID.
             EXEC SQL
                 INCLUDE SQLCA
             END-EXEC.
             EXEC SQL
                INCLUDE DCLGENF
             END-EXEC.
       LINKAGE SECTION.
       01    DFHCOMMAREA    PIC X(4).
       PROCEDURE DIVISION.
       MAIN-PARA.
             move dfhcommarea(1:eibcalen) to WS-COMM.
             MOVE LOW-VALUES TO LOCKERI.
             IF EIBCALEN = 0
                MOVE '2' TO WS-COMM
                PERFORM SEND-MAP THRU SEND-MAP-EXIT
                PERFORM RETURN-PARA THRU RETURN-EXIT
             ELSE
                PERFORM RECEIVE-PARA THRU RECEIVE-PARA-EXIT
                PERFORM KEY-PARA THRU KEY-PARA-EXIT
                PERFORM EXIT-PARA
             END-IF.
       SEND-MAP.
             EXEC CICS SEND
                MAP('LOCKER')
                MAPSET('ONLDEMO')
                FREEKB
                ERASE
             END-EXEC.
       SEND-MAP-EXIT.
             EXIT.
       RETURN-PARA.
             EXEC CICS RETURN
                 TRANSID('ONLD')
                 COMMAREA(WS-COMM)
             END-EXEC.
       RETURN-EXIT.
             EXIT.
       RECEIVE-PARA.
             MOVE LOW-VALUES TO LOCKERI.
             EXEC CICS RECEIVE
                 MAP('LOCKER')
                 MAPSET('ONLDEMO')
             END-EXEC.
       RECEIVE-PARA-EXIT.
             EXIT.
       KEY-PARA.
            EVALUATE EIBAID
               WHEN DFHPF5
                 PERFORM FETCH-PARA
                PERFORM SEND-MAP THRU SEND-MAP-EXIT
               WHEN OTHER
                    MOVE 'PRESS RIGHT KEY' TO MESSO
             END-EVALUATE.
       KEY-PARA-EXIT.
             EXIT.
       FETCH-PARA.
             MOVE NAMEI TO HI-NAME-TEXT.
             COMPUTE HI-NAME-LEN = FUNCTION LENGTH(NAMEI).
             MOVE PHONEI TO HI-PHONE-TEXT.
             COMPUTE HI-PHONE-LEN = FUNCTION LENGTH(PHONEI).
             

             
             EXEC SQL
                INSERT INTO DEMO_TABLE
                VALUES(:HI-NAME, :HI-PHONE)
             END-EXEC.
             IF SQLCODE = 0
                MOVE 'INSERT SUCCESSFULL' TO MESSO
             ELSE
                MOVE SQLCODE TO MESSO
                DISPLAY SQLCODE UPON SYSOUT
                DISPLAY SQLERRMC UPON SYSOUT
             END-IF.
       EXIT-PARA.
             EXEC CICS RETURN
             END-EXEC.
